Index: pri_facility.c
===================================================================
RCS file: /usr/cvsroot/libpri/pri_facility.c,v
retrieving revision 1.9
diff -u -r1.9 pri_facility.c
--- pri_facility.c	6 Apr 2005 19:42:41 -0000	1.9
+++ pri_facility.c	21 Apr 2005 19:09:16 -0000
@@ -633,7 +633,7 @@
 }
 
 /* Sending callername information functions */
-static int add_callername_facility_ies(struct pri *pri, q931_call *c)
+static int add_callername_facility_ies(struct pri *pri, q931_call *c, int cpe)
 {
 	int res = 0;
 	int i = 0;
@@ -680,8 +680,10 @@
 	ASN1_ADD_BYTECOMP(comp, ASN1_ENUMERATED, buffer, i, 0);
 	ASN1_FIXUP(compstk, compsp, buffer, i);
 
-	if (pri_call_apdu_queue(c, Q931_SETUP, buffer, i, NULL, NULL))
-		return -1;
+	if (!cpe) {
+		if (pri_call_apdu_queue(c, Q931_SETUP, buffer, i, NULL, NULL))
+			return -1;
+	}
 
 
 	/* Now the ADPu that contains the information that needs sent.
@@ -1236,12 +1238,21 @@
 	if (pri->localtype == PRI_NETWORK) {
 		switch (pri->switchtype) {
 			case PRI_SWITCH_NI2:
-				add_callername_facility_ies(pri, call);
+				add_callername_facility_ies(pri, call, 0);
+				break;
+			default:
+				break;
+		}
+	} else if (pri->localtype == PRI_CPE) {
+		switch (pri->switchtype) {
+			case PRI_SWITCH_NI2:
+				add_callername_facility_ies(pri, call, 1);
 				break;
 			default:
 				break;
 		}
 	}
+
 	return 0;
 }
 
